local _, TzTanaanBonus = ...
_G.TzTanaanBonus = TzTanaanBonus

TzTanaanBonus.worldmap_icons = {}
TzTanaanBonus.worldmap_frame = CreateFrame( 'frame', nil, WorldMapButton )
TzTanaanBonus.worldmap_frame:SetAllPoints()

local function TzTanaanBonus_HideIcons()
	for iconIndex, icon in pairs( TzTanaanBonus.worldmap_icons ) do
		icon:Hide()
	end
end

local function TzTanaanBonus_Icon_OnEnter( _self )
	if _self.text then
		WorldMapPOIFrame.allowBlobTooltip = false
		WorldMapTooltip:SetOwner( _self, 'ANCHOR_BOTTOMLEFT' )
		WorldMapTooltip:ClearLines()
		WorldMapTooltip:AddLine( _self.text )

		if TomTom then
			WorldMapTooltip:AddLine( "Ctrl-Click to set a TomTom waypoint", 1, 1, 1, true )
		end

		WorldMapTooltip:Show()
	end
end

local function TzTanaanBonus_Icon_OnLeave()
	WorldMapPOIFrame.allowBlobTooltip = true
	WorldMapTooltip:Hide()
end

local function TzTanaanBonus_Icon_OnMouseUp( _self )
	if TomTom and IsControlKeyDown() then
		local mapID, mapFloor = GetCurrentMapAreaID()
		local width, height = WorldMapDetailFrame:GetWidth(), WorldMapDetailFrame:GetHeight()
		local _, _, _, x, y = _self:GetPoint()

		x = x / width
		y = -y / height

		TomTom:AddMFWaypoint( mapID, mapFloor, x, y, { title = format( "Bonus Objective: %s", _self.text ), persistent = false, } )
	end
end

local function TzTanaanBonus_GetIcon()
	for iconIndex, icon in pairs( TzTanaanBonus.worldmap_icons ) do
		if not icon:IsShown() then
			return icon
		end
	end

	local icon = CreateFrame( 'frame', nil, TzTanaanBonus.worldmap_frame )

	icon.texture = icon:CreateTexture()
	icon.texture:SetAllPoints()
	icon.texture:SetTexture( 'interface/minimap/objecticons' )
	icon.texture:SetTexCoord( GetObjectIconTextureCoords( 47 ) )

	icon:SetSize( 32, 32 )
	icon:SetAlpha( 1.0 )
	icon:EnableMouse( true )

	icon:SetScript( 'OnEnter', TzTanaanBonus_Icon_OnEnter )
	icon:SetScript( 'OnLeave', TzTanaanBonus_Icon_OnLeave )
	icon:SetScript( 'OnMouseUp', TzTanaanBonus_Icon_OnMouseUp )

	tinsert( TzTanaanBonus.worldmap_icons, icon )

	return icon
end

hooksecurefunc( 'WorldMapFrame_Update', function()
	TzTanaanBonus_HideIcons()

	if GetCurrentMapAreaID() == 945 then
		for _, info in pairs( TzTanaanBonus.database ) do
			completed = false

			for dbIndex = 4, #info, 1 do
				if IsQuestFlaggedCompleted( info[ dbIndex ] ) then
					completed = true
				end
			end

			if not completed then
				local icon = TzTanaanBonus_GetIcon()

				icon:SetPoint( 'CENTER', WorldMapDetailFrame, 'TOPLEFT', info[ 2 ], -info[ 3 ] )
				icon.text = info[ 1 ]
				icon:Show()
			end
		end
	end
end )
